<template>
  <div class="w-full">
    <div
      v-if="isMobile"
      class="flex items-center time-notice-footer p-2 statement-time-notice"
    >
      <el-icon class="mx-1">
        <clock />
      </el-icon>
      <p>{{ $t("All_transactions_are_time_stamped_at_GMT-4") }}</p>
    </div>
    <div v-if="themeName === 'peru'">
      <div
        v-loading="isLoading"
        class="hidden-mobile-version my-promotion-page"
      >
        <div v-if="!isLoading">
          <lazy-utils-not-found
            v-if="promotion.PromotionApplyList.length === 0"
          />
          <template v-else>
            <div
              v-for="(data, index) in promotion.PromotionApplyList"
              :key="index"
              shadow="always"
              class="mb-[16px] padding-custom"
            >
              <div
                class="py-[6px] px-[20px] border-b-2 divider-color text-[12px] leading-4 font-[400]"
              >
                <div class="flex justify-between">
                  <div class="whitespace-nowrap">{{ $t("title") }}</div>
                  <div class="col-span-2 text-right">
                    {{ data.PromotionTitle }}
                  </div>
                </div>
                <div class="flex justify-between">
                  <div class="whitespace-nowrap">
                    {{ $t("promotion_code") }}
                  </div>
                  <div class="col-span-2 text-right">{{ data.PromoCode }}</div>
                </div>
                <div class="flex justify-between">
                  <div class="whitespace-nowrap">{{ $t("start_date") }}</div>
                  <div class="col-span-2 text-right">{{ data.StartDate }}</div>
                </div>
                <div class="flex justify-between">
                  <div class="whitespace-nowrap">{{ $t("end_date") }}</div>
                  <div class="col-span-2 text-right">{{ data.StartDate }}</div>
                </div>
              </div>
              <div
                class="py-[6px] px-[20px] border-b-2 divider-color text-[12px] leading-4 font-[400]"
              >
                <div class="flex justify-between">
                  <div class="whitespace-nowrap">
                    {{ $t("approved_amount") }}
                  </div>
                  <div class="col-span-2 text-right">
                    {{ data.VerifiedAmountForDisplay }}
                  </div>
                </div>
                <div class="flex justify-between">
                  <div>{{ $t("turnover") }}</div>
                  <div class="col-span-2 text-right">
                    {{ data.TurnoverForDisplay }}
                  </div>
                </div>
              </div>
              <div class="py-[6px] px-[20px] text-[12px] leading-4 font-[400]">
                <div class="flex justify-between">
                  <div>{{ $t("status") }}</div>
                  <div
                    class="col-span-2 text-right text-[16px]"
                    :class="`fc-${data.colorClass}`"
                  >
                    {{ data.Status }}
                  </div>
                </div>
                <el-progress
                  v-if="data.Status === approved"
                  :text-inside="true"
                  :stroke-width="20"
                  :percentage="data.Progress"
                  class="mt-2"
                />
              </div>
            </div>
          </template>
        </div>
      </div>
      <el-scrollbar class="hidden-desktop-version">
        <div class="relative w-full mx-auto my-promotion-page">
          <el-table
            v-loading="isLoading"
            :data="promotion.PromotionApplyList"
            width="100"
            height="auto"
          >
            <template #empty>
              <lazy-utils-not-found />
            </template>
            <el-table-column
              prop="RequestId"
              label="#"
              min-width="70"
              align="center"
            />
            <el-table-column :label="$t('title')" align="center">
              <el-table-column
                :label="$t('promotion_code')"
                min-width="140"
                align="center"
              >
                <template #default="scope">
                  <span>{{ scope.row.PromotionTitle }}</span>
                  <p class="text-[12px]">{{ scope.row.PromoCode }}</p>
                </template>
              </el-table-column>
            </el-table-column>
            <el-table-column
              prop="RequestedOn"
              :label="$t('requested_on')"
              min-width="140"
              align="center"
            />
            <el-table-column :label="$t('start_date')" align="center">
              <el-table-column
                :label="$t('end_date')"
                min-width="100"
                align="center"
              >
                <template #default="scope">
                  <span>{{ scope.row.StartDate }}</span>
                  <p class="text-[12px]">{{ scope.row.EndDate }}</p>
                </template>
              </el-table-column>
            </el-table-column>
            <el-table-column
              prop="VerifiedAmountForDisplay"
              :label="$t('approved_amount')"
              min-width="150"
              align="right"
              header-align="center"
            />
            <el-table-column
              prop="TurnoverForDisplay"
              :label="$t('turnover')"
              min-width="100"
              align="right"
              header-align="center"
            />
            <el-table-column
              prop="Status"
              :label="$t('status')"
              min-width="100"
              align="left"
              header-align="center"
            >
              <template #default="scope">
                <span :class="`fc-${scope.row.colorClass}`">{{
                  scope.row.Status
                }}</span>
              </template>
            </el-table-column>
            <el-table-column
              :label="$t('turnover_progress')"
              min-width="120"
              align="center"
            >
              <template #default="scope">
                <el-progress
                  v-if="scope.row.Status === approved"
                  :text-inside="true"
                  :stroke-width="20"
                  :percentage="scope.row.Progress"
                />
              </template>
            </el-table-column>
          </el-table>
        </div>
      </el-scrollbar>
    </div>
    <div
      v-else
      v-loading="isLoading"
      class="my-promotion px-2 pb-2 pt-1 relative min-h-[120px] flex flex-col gap-2"
    >
      <lazy-utils-not-found
        v-if="!isLoading && !promotion.PromotionApplyList?.length"
      />
      <template v-else-if="!isLoading">
        <card-m-bk8-transaction-card
          v-for="promo in promotion.PromotionApplyList"
          :key="promo.RequestId"
        >
          <template #title>
            <h3 class="text-[14px]" :class="`fc-${promo.colorClass}`">
              {{ $t(promo.Status) }}
            </h3>
          </template>
          <div class="flex justify-between items-center mb-3">
            <p>{{ $t("title") }}</p>
            <p class="font-bold">{{ promo.PromotionTitle }}</p>
          </div>
          <div class="flex justify-between items-center mb-3">
            <p>{{ $t("promotion_code") }}</p>
            <p class="font-bold">{{ promo.PromoCode }}</p>
          </div>
          <div class="flex justify-between items-center mb-3">
            <p>{{ $t("request_on") }}</p>
            <p class="font-bold">{{ promo.RequestedOn }}</p>
          </div>
          <div class="flex justify-between items-center mb-3">
            <p>{{ $t("duration") }}</p>
            <p class="font-bold">{{ promo.Duration }}</p>
          </div>
          <div class="flex justify-between items-center mb-3">
            <p>{{ $t("approved_amount") }}</p>
            <p class="font-bold fc-success">
              {{ promo.VerifiedAmountForDisplay }}
            </p>
          </div>
          <div class="flex justify-between items-center mb-3">
            <p>{{ $t("turnover") }}</p>
            <p class="font-bold fc-success">{{ promo.TurnoverForDisplay }}</p>
          </div>
          <el-progress
            v-if="promo.Status === approved"
            :text-inside="true"
            :stroke-width="20"
            :percentage="promo.Progress"
          />
        </card-m-bk8-transaction-card>

        <!-- TODO: Will remove later -->

        <!-- <el-card
          v-for="(data, index) in promotion.PromotionApplyList"
          v-else
          :key="index"
          shadow="always"
          class="my-5"
        >
          <div class="grid grid-cols-3 gap-2">
            <div class="whitespace-nowrap">{{ $t("title") }}</div>
            <div class="col-span-2 text-right">{{ data.PromotionTitle }}</div>
            <div class="whitespace-nowrap">{{ $t("promotion_code") }}</div>
            <div class="col-span-2 text-right">{{ data.PromoCode }}</div>
            <div class="whitespace-nowrap">{{ $t("request_on") }}</div>
            <div class="col-span-2 text-right">{{ data.RequestedOn }}</div>
            <div class="whitespace-nowrap">{{ $t("start_date") }}</div>
            <div class="col-span-2 text-right">{{ data.StartDate }}</div>
            <div class="whitespace-nowrap">{{ $t("end_date") }}</div>
            <div class="col-span-2 text-right">{{ data.EndDate }}</div>
            <div class="whitespace-nowrap">{{ $t("approved_amount") }}</div>
            <div class="col-span-2 text-right">
              {{ data.VerifiedAmountForDisplay }}
            </div>
            <div>{{ $t("turnover") }}</div>
            <div class="col-span-2 text-right">
              {{ data.TurnoverForDisplay }}
            </div>
            <div>{{ $t("status") }}</div>
            <div class="col-span-2 text-right" :class="`fc-${data.colorClass}`">
              {{ data.Status }}
            </div>
          </div>
          <el-progress
            v-if="data.Status === approved"
            :text-inside="true"
            :stroke-width="20"
            :percentage="data.Progress"
            class="mt-2"
          />
        </el-card> -->
      </template>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent } from "vue";
import { Clock } from "@element-plus/icons-vue";
import { store } from "~~/store";

export default defineComponent({
  components: { Clock },
  props: {
    containerClass: {
      type: String,
      default: "",
    },
    theme: {
      type: String,
      default: "",
    },
  },
  setup() {
    const { promotion, approved, isLoading } = useMyPromotion();
    const isMobile = !useIsDesktop();
    const themeColor = computed(() =>
      store.state.companyThemePropertiesFromApi.ThemeProperties.find(
        (t) => t.HtmlId === "theme_color"
      )
    );
    const isBK8Mobile = computed(
      () =>
        themeColor.value &&
        isMobile &&
        themeColor.value.Text.toLowerCase() === "bk8"
    );
    const themeName = store.state.selectedThemeName;
    return {
      promotion,
      approved,
      isLoading,
      isBK8Mobile,
      themeName,
      isMobile,
    };
  },
});
</script>

<style scoped>
.my-promotion {
  :deep(.el-loading-mask) {
    background-color: transparent;
  }
}
.padding-custom {
  border-radius: 8px;
  border: 2px solid #36412e;
}
.divider-color {
  border-color: var(--border);
}
.transaction-page .common-global .promotion-history-wrapper.flex-auto {
  height: auto;
  padding-bottom: 8px;
}
</style>
